// C Header File
// Created 11/9/2002; 8:23:08 PM
/*
short ball_spr[16]=
{
	0b0000000000000000,
	0b0000011111100000,
	0b0000111111110000,
	0b0001111111111000,
	0b0011111111111100,
	0b0111111111111110,	
	0b0111111111111110,
	0b0111111111111110,
	0b0111111111111110,
	0b0111111111111110,
	0b0111111111111110,
	0b0011111111111100,
	0b0001111111111000,
	0b0000111111110000,
	0b0000011111100000,
	0b0000000000000000
};
short ball_mask[16]=
{
	~0b0000011111100000,
	~0b0000111111110000,
	~0b0001111111111000,
	~0b0011111111111100,
	~0b0111111111111110,
	~0b1111111111111111,	
	~0b1111111111111111,
	~0b1111111111111111,
	~0b1111111111111111,
	~0b1111111111111111,
	~0b1111111111111111,
	~0b0111111111111110,
	~0b0011111111111100,
	~0b0001111111111000,
	~0b0000111111110000,
	~0b0000011111100000
};*/

void DrawMainBall(void)
{
//	GraySprite16_MASK(xpos,ypos,16,ball_spr,ball_spr,ball_mask,ball_mask,light,dark);
	//GraySprite32_MASK(xpos,ypos,13,ship_spr[0],ship_spr[1],ship_spr[2],ship_spr[2],light,dark);
	GraySprite16_MASK(xpos,ypos,16,TILEADDR_BALLS(0,ballspritecycle),
	TILEADDR_BALLS(1,ballspritecycle),TILEADDR_BALLS(0,NR_BALLS),
	TILEADDR_BALLS(1,NR_BALLS),light,dark);
}


static inline void buildcoordtable(void)               // dynamic AND highly optimized =)
{
    #define leftoffset			((SCREEN_WIDTH-PLANE_WIDTH)/2)
    #define topoffset           ((PLANE_WIDTH-(PLANE_WIDTH/4))/2)
    #define botoffset           0
    #define topdelta            ((PLANE_WIDTH/4)/8)
    #define botdelta            (PLANE_WIDTH/8)
    #define topleft(i)          (topoffset+i*topdelta)
    #define botleft(i)          (botoffset+i*botdelta)
    // #define fixedslope(i,line) (((65536*(topleft(i)-botleft(i))*(line))/PLANE_HEIGHT)/65536)
    // for better rounding and forced >>16 optimization, use this instead:
    #define fixedslope(i,line)  (((65536*(topleft(i)-botleft(i))+PLANE_HEIGHT/2)/PLANE_HEIGHT*(line)+65536/2)>>16)

    short i, j;
    BYTE* coordptr = coordtable;
    BYTE* coordtemp;
    
    for (i=0; i<PLANE_HEIGHT; ++i)
     {
        short temp = PLANE_HEIGHT-i;

        *(coordptr++) = fixedslope(0,temp)+botleft(0)+leftoffset;
        *(coordptr++) = fixedslope(1,temp)+botleft(1)+leftoffset-1;
        *(coordptr++) = fixedslope(1,temp)+botleft(1)+leftoffset;
        *(coordptr++) = fixedslope(2,temp)+botleft(2)+leftoffset-1;
        *(coordptr++) = fixedslope(2,temp)+botleft(2)+leftoffset;
        *(coordptr++) = fixedslope(3,temp)+botleft(3)+leftoffset-1;
        *(coordptr++) = fixedslope(3,temp)+botleft(3)+leftoffset;
        *(coordptr)   = fixedslope(4,temp)+botleft(4)+leftoffset-1;
        coordtemp = coordptr++;
        for (j=0;j<8;j++)
        	*(coordptr++) = SCREEN_WIDTH-1-*(coordtemp--);
     }

	#undef leftoffset
    #undef topoffset
    #undef botoffset
    #undef topdelta
    #undef botdelta
    #undef topleft
    #undef botleft
    #undef fixedslope
}

static inline void newtile(void)
{
	short i;

	scrollcycle = 0;
	tilecycle = 0;

// neither of these calculations is great; I'll write a better one later

// recursive-like calculation
	tileoffsets[0] = 0;
	for (i=1; i<NUM_TILES_HIGH; ++i)
		tileoffsets[i] = tileoffsets[i-1]+i*TOP_TILE_HEIGHT;
// closed-formula calculation
//	for (i=0; i<NUM_TILES_HIGH; ++i)
//		tileoffsets[i] = TOP_TILE_HEIGHT*i*(i+1)/2;	
}

static inline void drawinitialplane(void)
{
	short i, j, line = 0;
	const BYTE* dataptr;

	newtile();	
	toptileindex = LEVELSIZE-NUM_TILES_HIGH-1;
	dataptr = leveldata[level]+toptileindex+1;
	
	for (i=0; i<NUM_TILES_HIGH; ++i)
	 {
		for (j=0; j<((i+1)*TOP_TILE_HEIGHT); ++j)
		 {
		 	drawplaneline(*dataptr, line);
		 	++line;
		 }
		++dataptr;
	 }
}

static inline void drawplaneline(BYTE data, short line)
{
	short bitnum = 7, startx, endx, i;
	BYTE* coordptr = coordtable+8*2*line;
  unsigned long* tempptrl = (unsigned long*)(track_light+30*line);
  unsigned long* tempptrd = (unsigned long*)(track_dark+30*line);
  unsigned long* gfxptrl = (unsigned long*)(sky+30*line);
  unsigned long* gfxptrd = (unsigned long*)(sky+3840+30*line);  

	for (i=0; i<7; i++)
	{
    	*tempptrl++ = *gfxptrl++;		
    	*tempptrd++ = *gfxptrd++;		
	}
    *(unsigned short*)tempptrl = *(unsigned short*)gfxptrl;	 	
    *(unsigned short*)tempptrd = *(unsigned short*)gfxptrd;
	do
	 {
		while (bitnum>=0 && !(data&(1<<bitnum)))
		 {
		 	coordptr += 2;
			--bitnum;
		 }
		if (bitnum < 0)
			break;
		startx = *(coordptr++);
		endx   = *(coordptr++);
		while ((--bitnum)>=0 && (data&(1<<bitnum)))
		 {
			coordptr++;
		 	endx = *(coordptr++);
		 }
		ModifiedFastDrawHLine(track_light, startx, endx, line);
		ModifiedFastDrawHLine(track_dark, startx, endx, line);
		
		
		if (bitnum == 0)
			coordptr+=2;
	 } while (bitnum>0);
}

// each time this function is called, it will ... do something
static inline short ScrollPlane(void)
{
	short currenttile, tempindex;

	if (scrollcycle == (NUM_TILES_HIGH*TOP_TILE_HEIGHT))
	 {
	 	// update score, move to next tile, etc
	 	newtile();
	 	--toptileindex;
	 	if (toptileindex < 0)
	 		toptileindex = LEVELSIZE-1;
	 }
	if (tilecycle == NUM_TILES_HIGH)
		tilecycle = 0;	
	tempindex = toptileindex+tilecycle;
	
	for (currenttile=tilecycle; currenttile<NUM_TILES_HIGH; ++currenttile)
	 {
	 	if (tempindex >= (short)(LEVELSIZE-1))
	 		{
	 		if(duringintro) tempindex -= (short)LEVELSIZE;
	 		else return 0;	 			
	 		}

	 	drawplaneline(leveldata[level][tempindex], tileoffsets[currenttile]);
	 	++tempindex;
	 	++tileoffsets[currenttile];
	 }
	++tilecycle;
	++scrollcycle;
	
	return 1;
}


// line routine will probably be overhauled for better integration into PJ

/* function borrowed from extgraph and further optimized for our needs -- thanks Tom! */
#define ASM_SWAP(val) ({\
    register unsigned long tmp = val;\
    asm volatile ("swap %0" : "=d" (tmp) : "0" (tmp));\
    tmp;})

static inline void ModifiedFastDrawHLine(unsigned char* plane,short x1,short x2,short y) {
    static const unsigned short table1[16] = {0xffff,0x7fff,0x3fff,0x1fff,
                                              0x0fff,0x07ff,0x03ff,0x01ff,
                                              0x00ff,0x007f,0x003f,0x001f,
                                              0x000f,0x0007,0x0003,0x0001};
    static const unsigned short table2[16] = {0x0000,0x8000,0xc000,0xe000,
                                              0xf000,0xf800,0xfc00,0xfe00,
                                              0xff00,0xff80,0xffc0,0xffe0,
                                              0xfff0,0xfff8,0xfffc,0xfffe};
    short           dx;
    short           sx;
    unsigned short* p;

    if (x1>x2) {
        short tmp = x1;
        x1 = x2;
        x2 = tmp;
    }

    p  = (unsigned short*)(plane+(y<<5)-(y<<1)+((x1>>3)&0x1e));
    dx = x2-x1+1;
    sx = x1 & 0x000f;

    if (dx<16) {
        unsigned long val = (ASM_SWAP(table2[dx])) >> sx;
        *(unsigned long*)p |= val;
        return;
    }

    if (sx) {
        *p++ |= table1[sx];
        dx -= (16-sx);
    }
    while (dx >= 16) {
        *p++ |= 0xffff;
        dx-=16;
    }
    if (dx) *p |= table2[dx];
}

static inline void drawcollisionline(BYTE data, short collide_y, char* ptr)
{
	short bitnum = 7, startx, endx, i;
	BYTE* coordptr = coordtable+8*2*collide_y;
  unsigned long* tempptr = (unsigned long*)(ptr);

	for (i=0; i<7; i++)
	{
    	*tempptr++ = 0;
	}
    *(unsigned short*)tempptr = 0;
	do
	 {
		while (bitnum>=0 && !(data&(1<<bitnum)))
		 {
		 	coordptr += 2;
			--bitnum;
		 }
		if (bitnum < 0)
			break;
		startx = *(coordptr++);
		endx   = *(coordptr++);
		while ((--bitnum)>=0 && (data&(1<<bitnum)))
		 {
			coordptr++;
		 	endx = *(coordptr++);
		 }
		ModifiedFastDrawHLine(ptr, startx, endx, 0);
		
		if (bitnum == 0)
			coordptr+=2;
	 } while (bitnum>0);
}


void ShowIntro(short time)
{
	short a=0;
	long timer;
#define leftx ((SCREEN_WIDTH/2)-48)
	drawinitialplane();
	zspeed = ACCELERATION_TIME;	   
	duringintro = 1;
	
	while(_rowread(0)) continue;
	
	while(!_rowread(0) || ((time==AT_END)?(a<100):0))
	{
	ScrollPlane();
	FastCopyScreen(track_light,light);
	FastCopyScreen(track_dark,dark);		
	GraySprite32_MASK(leftx,26,48,
	TILEADDR_TITLE_SPR(0,0),TILEADDR_TITLE_SPR(1,0),
	TILEADDR_TITLE_MASK(0),TILEADDR_TITLE_MASK(0),
	light,dark);
	GraySprite32_MASK(leftx+32,26,48,
	TILEADDR_TITLE_SPR(0,1),TILEADDR_TITLE_SPR(1,1),
	TILEADDR_TITLE_MASK(1),TILEADDR_TITLE_MASK(1),
	light,dark);
	GraySprite32_MASK(leftx+64,26,48,
	TILEADDR_TITLE_SPR(0,2),TILEADDR_TITLE_SPR(1,2),
	TILEADDR_TITLE_MASK(2),TILEADDR_TITLE_MASK(2),
	light,dark);	
	if(time == AT_END)
	{
	GraySprite32_MASK(leftx,82,16,
	TILEADDR_COMPLETE_SPR(0,0),TILEADDR_COMPLETE_SPR(1,0),
	TILEADDR_COMPLETE_MASK(0),TILEADDR_COMPLETE_MASK(0),
	light,dark);
	GraySprite32_MASK(leftx+32,82,16,
	TILEADDR_COMPLETE_SPR(0,1),TILEADDR_COMPLETE_SPR(1,1),
	TILEADDR_COMPLETE_MASK(1),TILEADDR_COMPLETE_MASK(1),
	light,dark);
	GraySprite32_MASK(leftx+64,82,16,
	TILEADDR_COMPLETE_SPR(0,2),TILEADDR_COMPLETE_SPR(1,2),
	TILEADDR_COMPLETE_MASK(2),TILEADDR_COMPLETE_MASK(2),
	light,dark);	
	}
	FastCopyScreen(light,GetPlane(LIGHT_PLANE));
	FastCopyScreen(dark,GetPlane(DARK_PLANE));
		if(time==AT_END && !a)
		{
				for (a = 0; a < 7; a++) {
			OSContrastUp();
			if(HW2) OSContrastUp();
			for (timer = 0; timer < 50000; timer++);
					}		
		}
	a++;
	}
	while(_rowread(0)) continue;
	duringintro = 0;
}

void ShowInfo(void)
{
		ClearGrayScreen();
		DrawGrayStrExt(0,10,(char*)title_version_string,A_NORMAL|A_CENTERED|A_SHADOWED,F_8x10);
		DrawGrayStrExt(0,25,(char*)author_string,A_NORMAL|A_CENTERED|A_SHADOWED,F_8x10);
		DrawGrayStrExt(0,50,(char*)"Press Enter to Begin",A_NORMAL|A_CENTERED|A_SHADOWED,F_6x8);
		DrawGrayStrExt(0,60,(char*)"Arrows Left & Right = Move Left & Right",A_NORMAL|A_CENTERED|A_SHADOWED,F_4x6);
		DrawGrayStrExt(0,67,(char*)"Arrows Up & Down = Accelerate & Slow Down",A_NORMAL|A_CENTERED|A_SHADOWED,F_4x6);
		DrawGrayStrExt(0,74,(char*)"2nd = Partial Jump",A_NORMAL|A_CENTERED|A_SHADOWED,F_4x6);
		DrawGrayStrExt(0,81,(char*)"Diamond = Full Jump",A_NORMAL|A_CENTERED|A_SHADOWED,F_4x6);
		DrawGrayStrExt(0,88,(char*)"ESC = Quit",A_NORMAL|A_CENTERED|A_SHADOWED,F_4x6);
		
		while(!_keytest(RR_ENTER) && !_keytest(RR_ESC)) continue;			
}

void DrawLives(void)
{
	char buf[2] = {0,0};
	buf[0] = (char)'0' + lives;
	DrawGrayStrExt2B(0,0,buf,A_REVERSE,F_6x8,light,dark);
}

void ShowDeath(void)
{
	short a = 0, b = 92;
	long timer;
	memset(track_dark,0xFF,3840);
	FastCopyScreen(track_dark,GetPlane(0));
	FastCopyScreen(track_dark,GetPlane(1));
	DrawGrayStrExt2B(0,a,(char*)"Game Over",A_REVERSE|A_SHADOWED|A_CENTERED,F_6x8,light,dark);
	DrawGrayStrExt2B(0,b,(char*)"Press Enter",A_REVERSE|A_SHADOWED|A_CENTERED,F_6x8,light,dark);
				for (a = 0; a < 7; a++) {
				OSContrastDn();
				if(HW2) OSContrastDn();
				for (timer = 0; timer < 50000; timer++);
			}		
	
	while(!_keytest(RR_ENTER))
	{
		if(a<40)
		{
		FastCopyScreen(track_dark,light);
		FastCopyScreen(track_dark,dark);
		DrawGrayStrExt2B(0,a,(char*)"Game Over",A_REVERSE|A_SHADOWED|A_CENTERED,F_6x8,light,dark);
		DrawGrayStrExt2B(0,b,(char*)"Press Enter",A_REVERSE|A_SHADOWED|A_CENTERED,F_6x8,light,dark);
		FastCopyScreen(light,GetPlane(0));
		FastCopyScreen(dark,GetPlane(1));
			a++;
			b--;			
		}
	}
}
