#include "extgraph.h"

#define inverserectangle(w,xa,xb) InvertGrayRect(xa,w,xb,w+10)

typedef struct
{
	unsigned char left;
	unsigned char right;
	unsigned char up;
	unsigned char down;
	unsigned char esc;
	unsigned char confirm;
} Keystat;

Keystat* KeysCheck(Keystat* keystat)
{
memset(keystat,0,sizeof(Keystat));
//	AllKeysReleased();
	if(_keytest(RR_ESC)) keystat->esc = 1;
	else if(_keytest(RR_UP)) keystat->up = 1;
	else if(_keytest(RR_DOWN)) keystat->down = 1;
	else if(_keytest(RR_LEFT)) keystat->left = 1;
	else if(_keytest(RR_RIGHT)) keystat->right = 1;
	else if(_keytest(RR_ENTER1)||_keytest(RR_ENTER2)||_keytest(RR_HAND)||
	 _keytest(RR_F1)||_keytest(RR_2ND)) keystat->confirm = 1;
//	AllKeysReleased();	
return keystat;
}

/* Function for displaying and returning selected menu option */
int
domenu (char x, char y, char setmenu[], char comps, short choice)
{
Keystat keystat;
  int w = 0, changed = 1, i, j, exit = 0;
  int total = comps;
  int totalplace = 0;
  FontSetSys (F_6x8);
  if (comps > 7)
    comps = 7;
  w = choice;
  ClearGrayScreen ();
  //SetBackground (display_offsetx, display_offsety, GetPlane (0));
  while (exit == 0)
    {
      if (changed == 1)
	{
	  if (totalplace < 0)
	    totalplace = 0;
	  comps = total - totalplace;
	  if (comps > 7)
	    comps = 7;
	  for (i = totalplace, j = 0; i < comps + totalplace; i++, j++)
	    {
	      DrawGrayStr (x, 10 * j + y, setmenu + 9 * i, A_NORMAL);
	    }
	  inverserectangle (10 * w + y - 1, x - 1, 145);
	  changed = 0;
	}
KeysCheck(&keystat);
      if (keystat.up || keystat.left)
	{
	AllKeysReleased();	
	  inverserectangle (10 * w + y - 1, x - 1, 145);
	  if (w == 0)
	    {
	      if (totalplace > 7)
		{
		  totalplace -= 7;
		  w = 7;
		}
	      else
		{
		  //w = comps;
		}
	    }

	  if (w > 0)
	    w--;
	  changed = 1;
	}
      else if (keystat.down || keystat.right)
	{
	AllKeysReleased();	
	  inverserectangle (10 * w + y - 1, x - 1, 145);
	  if (w == comps - 1)
	    {
	      if (total > totalplace + 7)
		{
		  totalplace += 7;
		}
	      else
		totalplace = 0;
	      w = -1;
	    }

	  if (w < comps - 1)
	    w++;
	  if (w == -1)
	    w = 0;
	  changed = 1;
	}
      else if (keystat.esc)
	{
	AllKeysReleased();	
	  exit++;
	}
      else if (keystat.confirm)
	{
	AllKeysReleased();	
	  return w + totalplace;
	}


    }
  return -1;
}






















void LoadExternalLevel(void)
{
	char buffer[HOWMANY * MAXLEN];
	short number;
	SYM_ENTRY *symptr = NULL;
	char filestr[9] = { 0 };
  unsigned char *filedata;
	
	number = findAllFilesSet (buffer, "srlv", HOWMANY);
	if(!number) return;
	number = domenu (35, 28, buffer, number, 0);
	if(number==-1) return;
		  strcpy (filestr, buffer + number * MAXLEN);
	  symptr = DerefSym (SymFind (SYMSTR (filestr)));
	  if (!symptr) return;
	      filedata = HLock (symptr->handle);
	      filedata += 2;

//next comes a list of MAP_HEADERS
MAP_HEADER *header = (MAP_HEADER *) (filedata);

levelsizes[LEVELCOUNT] = header->ysize;
while(_rowread(0)) continue;
ClearGrayScreen();
DrawGrayStrExt(0,30,header->title,A_NORMAL|A_CENTERED|A_SHADOWED,F_6x8);
DrawGrayStrExt(0,50,header->author,A_NORMAL|A_CENTERED|A_SHADOWED,F_6x8);
DrawGrayStrExt(0,70,(char*)"Press a Key",A_NORMAL|A_CENTERED|A_SHADOWED,F_6x8);
while(!_rowread(0)) continue;

//next comes the actual tilemaps
	      unsigned char *map_data =
		(unsigned char *) (filedata +  sizeof (MAP_HEADER));
	      external_level =
		(char *) malloc (sizeof (char) * levelsizes[LEVELCOUNT]);
	      if (external_level == NULL)
		return;
	      memcpy (external_level, map_data,  sizeof (char) * levelsizes[LEVELCOUNT]);
    HeapUnlock (symptr->handle);		   
leveldata[LEVELCOUNT] = external_level;    
    level = LEVELCOUNT;   
}


