// C Header File
// Created 7/9/2001; 4:10:14 PM
//Simple saving routine, mostly thanks to John David Ratliff
//Checks if a certain file is archived
char
checkarchived (char *filestr)
{

  SYM_ENTRY *symptr;
  symptr = SymFindPtr (SYMSTR (filestr), 0);
  if (symptr->flags.bits.archived == 1)
    return 1;
  return 0;
}

#ifndef NO_SAVE_FILE_SUPPORT
void
savefile (MAP_HEADER * cur, char *filestr)
{
  FILE *f = fopen (filestr, "wb");
  short int n = 1;
// we must check to see if we opened the file successfully
  if (f != NULL)
    {
//Writes in the whole char map array, including string data
      fwrite (cur, sizeof (MAP_HEADER), 1, f);
      n = fwrite (vidmem, sizeof (char), map_height, f);
      if (n != map_height)
	{
//Error
	}
      fputc (0, f);
      fputs ("srlv", f);
      fputc (0, f);
      fputc (OTH_TAG, f);
      fclose (f);
    }
  else
    {
//Error
    }

}
#endif

//String Input Routines
//Thanks to Zeljko Juric, probably

void
InputStr (char *buffer, short maxlen)
{
//Thanks to the TIGCCLIB documentation!
  SCR_STATE ss;
  short key, i = 0;
  buffer[0] = 0;
  SaveScrState (&ss);
  do
    {
      MoveTo (ss.CurX, ss.CurY);
      printf ("%s_  ", buffer);
      // Two spaces are required if F_4x6 font is used
      key = ngetchx ();

      if (((isalpha (key)) || (isdigit (key) && i > 0)) && i < maxlen)
	buffer[i++] = key;
      if (key == KEY_BACKSPACE && i)
	i--;
      buffer[i] = 0;
    }
  while (key != KEY_ENTER);
}

void
InputInfo (char *buffer, short maxlen)
{
//Thanks to the TIGCCLIB documentation!
  SCR_STATE ss;
  short key, i = 0;
  buffer[0] = 0;
  SaveScrState (&ss);
  do
    {
      MoveTo (ss.CurX, ss.CurY);
      printf ("%s_  ", buffer);
      // Two spaces are required if F_4x6 font is used
      key = ngetchx ();
      if (key >= ' ' && key <= '~' && i < maxlen)
	buffer[i++] = key;
      if (key == KEY_BACKSPACE && i)
	i--;
      buffer[i] = 0;
    }
  while (key != KEY_ENTER);
  buffer[i] = '\0';
}

void
InputNum (char *buffer, short maxlen)
{
//Thanks to the TIGCCLIB documentation!
  SCR_STATE ss;
  short key, i = 0;
  buffer[0] = 0;
  SaveScrState (&ss);
  do
    {
      MoveTo (ss.CurX, ss.CurY);
      printf ("%s_  ", buffer);
      // Two spaces are required if F_4x6 font is used
      key = ngetchx ();

      if ((isdigit (key) && i < maxlen))
	buffer[i++] = key;
      if (key == KEY_BACKSPACE && i)
	i--;
      buffer[i] = 0;
    }
  while (key != KEY_ENTER);
}
