// C Header File
// Created 11/9/2002; 8:24:13 PM

void InitGameVars(void)
{
	zspeed = 0;
	xpos = spawnx;
	ypos = YPOS;
	wait = 0;
	hangtime = 0;
	lives = LIVES;
	jumpplace = 0;
	jumptype = 0;
	jumpdir = 0;
	ballspritecycle = 0;
	duringintro = 0;
	ballspritewait = 0;	
	endlev_quit = FALSE;
	death_quit = FALSE;
	mainIsJumping = FALSE;
	mainIsDescending = FALSE;	
	
}

void InitGlobals(void)
{
	spawnx = XPOS;
	InitGameVars();
	contrastcur = 0;
	level = random(LEVELCOUNT);

#if defined(USE_TI89)	
	jump = (RowCol){RR_2ND};
#elif defined(USE_TI92PLUS)
	jump = (RowCol){RR_HAND};
#elif defined(USE_V200)
	jump = (RowCol){RR_HAND};
#endif
}

// Adjusts contrast if +/- pressed.
void contrast(void)
{
	if (_keytest(RR_PLUS)) {
		contrastcur++;
		if (contrastcur == 6) {
			contrastcur = 0;
			OSContrastUp();
		}
	}
	if (_keytest(RR_MINUS)) {
		contrastcur++;
		if (contrastcur == 6) {
			contrastcur = 0;
			OSContrastDn();
		}
	}
}

#define RedirectInterrupts()  \
{\
	save_int_1 = GetIntVec(AUTO_INT_1);\
	save_int_5 = GetIntVec(AUTO_INT_5);\
	SetIntVec(AUTO_INT_1, DUMMY_HANDLER);\
	SetIntVec(AUTO_INT_5, DUMMY_HANDLER);\
}

#define ShowMemoryError() ST_helpMsg("ERROR: Not enough memory")

void FreeMemory(void)
{
			if(coordtable) free(coordtable);
			if(track_light) free(track_light);
			if(track_dark) free(track_dark);
			if(light) free(light);
			if(dark) free(dark);
}

short AllocateMemory(void)
{
	coordtable=(BYTE*)malloc(8*2*PLANE_HEIGHT);
  track_light = (char*)malloc(3840);
  track_dark = (char*)malloc(3840);
  light = (char*)malloc(3840);
  dark = (char*)malloc(3840);
  if(!coordtable || !track_light || !track_dark || !light || !dark)
  {
		ShowMemoryError();
		FreeMemory();
		return 0;
  }

	memset(coordtable, 0, 8*2*PLANE_HEIGHT);

  return 1; //Successful  
}

#define AllKeysReleased() \
	{while (_rowread(0)) continue;}
	
#ifndef USE_TI89
void InitBackground(void)
{
	short a;
//	memcpy((BYTE*)track_light+30*PLANE_HEIGHT,sky+30*PLANE_HEIGHT,(SCREEN_Y_DELTA)*30);
//	memcpy((BYTE*)track_dark+30*PLANE_HEIGHT,sky+3840+30*PLANE_HEIGHT,(SCREEN_Y_DELTA)*30);
	for(a=PLANE_HEIGHT;a<PLANE_HEIGHT+SCREEN_Y_DELTA;a+=2)
	{
		memset((BYTE*)track_light+30*a,0b01010101,30);
		memset((BYTE*)track_dark+30*a,0b10101010,30);		
	}
	for(a=PLANE_HEIGHT+1;a<PLANE_HEIGHT+SCREEN_Y_DELTA;a+=2)
	{
		memset((BYTE*)track_light+30*a,0b10101010,30);
		memset((BYTE*)track_dark+30*a,0b01010101,30);		
	}	
}
#endif

void LoadExternalLevel(void);

void PickLevel(void)
{
while(_rowread(0)) continue;
ClearGrayScreen();
DrawGrayStrExt(0,30,(char*)"Pick a level...",A_NORMAL|A_CENTERED|A_SHADOWED,F_8x10);
DrawGrayStrExt(0,42,(char*)"Enter [1] to [5]...",A_NORMAL|A_CENTERED|A_SHADOWED,F_8x10);
DrawGrayStrExt(0,54,(char*)"[0] for User Level...",A_NORMAL|A_CENTERED|A_SHADOWED,F_6x8);
DrawGrayStrExt(0,66,(char*)"Or [Enter] for a",A_NORMAL|A_CENTERED|A_SHADOWED,F_6x8);
DrawGrayStrExt(0,78,(char*)"randomly generated level.",A_NORMAL|A_CENTERED|A_SHADOWED,F_6x8);
	while(!_rowread(0)) continue;
		if(_keytest(RR_5)) level = 4;
		else if(_keytest(RR_4)) level = 3;
		else if(_keytest(RR_3)) level = 2;
		else if(_keytest(RR_2)) level = 1;
		else if(_keytest(RR_1)) level = 0;
		else if(_keytest(RR_ENTER)) level = 5;
		else if(_keytest(RR_0)) LoadExternalLevel();
	while(_rowread(0)) continue;
}

short FindSpawnPoint(void)
{
	short a,b;
	short length = 0;
	short is_a = 0;
char line[30];
drawcollisionline(leveldata[level]
[toptileindex+NUM_TILES_HIGH-((scrollcycle<36)?0:1)],
ypos+SHIP_Y-1,line);
	 for(a=(PLANE_WIDTH/2)-1,b=PLANE_WIDTH/2;b<PLANE_WIDTH;a--,b++)
	 {
	 	if(EXT_GETPIX(line,a,0)) {is_a = TRUE; break;}
		if(EXT_GETPIX(line,b,0)) {is_a = FALSE; break;}	
	 }
		if(b==PLANE_WIDTH) return 0; //No points on 
if(is_a)
{
		while(EXT_GETPIX(line,a-length,0) && 
		(a-length)>=0)
			length++;
	spawnx = a - (length/2) - (SHIP_X/2);	
}
else
{
		while(EXT_GETPIX(line,b+length,0) && 
		(b+length)<=PLANE_WIDTH)
			length++;
	spawnx = b + (length/2) - (SHIP_X/2);	
}
 	
	return 1;
}

void GenerateRandomLevel(short idx)
{
	short a;
	for(a=0;a<levelsizes[idx]-1;a++)
		leveldata[idx][a] = random(255);
	leveldata[idx][a] = 255;		
}











//=============================================================================
// VTI detection routine (thanx, Julien Muchembled)
//
// this routine utilizes a bug in VTI: you can set even non-existing flags in
// the status register and query them later!
//=============================================================================
extern short IsVTI(void);
asm("
IsVTI:
    trap   #12         /* enter supervisor mode. returns old (%sr) in %d0.w   */
    move.w #0x3000,%sr /* set a non-existing flag in %sr (but keep s-flag !!) */
    swap   %d0         /* save %d0.w content in upper part of %d0             */
    move.w %sr,%d0     /* get %sr content and check for non-existing flag     */
    btst   #12,%d0     /* this non-existing flag can only be set on the VTI   */
    bne    __VTI           
    swap   %d0         /* restore old %sr content and return 0                */
    move.w %d0,%sr
    moveq  #0,%d0
    rts
__VTI:
    swap   %d0         /* restore old %sr content and return 1                */
    move.w %d0,%sr
    moveq  #1,%d0
    rts
");





void DetectHardwareVersion(void)
{
	/* Checks the calculator hardware version */
	short *hwptr;
	hwptr = (short *) FL_getHardwareParmBlock();
	HW2 = (*hwptr)==42;
	if (IsVTI()) {
		HW2 = 0;	// Sets VTI to be HW1 because it has a HW1 contrast range
	}
/*----------------------------------------*/
}
